2chインターフェイスについて
============================

主にJane Styleで動作確認しています。

インストールについて
--------------------
* Python3.2.5 以降、あるいは 3.3.2 以降を使ってください。
  Python3.2.3 の urllib.parse ライブラリに不具合があるように見えるためです。
  Python3.2.5 の urllib.parse ライブラリで上書きしてもよいかもしれません。

投稿について
-------------
* 「>>レス番号」アンカーに対応しています。
  書き込み時の「>>レス番号」は自動で「>>ID」に、読み込み時の「>>ID]は自動で「>>レス番号」に変換します。
  なので2chのようにアンカーを読み書きできます。
  また、「>>レス番号」で書き込んでもブラウザからの閲覧では通常通り「>>ID」形式で表示されるのでご安心ください。
  ただし、「>>レス番号」はdatを読み込んだ時点での番号なので、時間をおいてから書き込みをすると実際のレスとずれてしまいます。

* 別スレへのリンクは新月標準の`[[スレタイ]]`形式を使ってください。
  他には`[[/thread/スレタイ]]`、`[[スレタイ/レスID]]`、`[[/thread/スレタイ/レスID]]`などがあります。

* 2chトリップに対応しています。
  「名前#トリップ」のようにすると新月の署名機能が使えます。
  adminでないノードでは使えません。

* ファイル添付はできません。

* 専ブラから新規スレッド作成としてコメントできます。
  そのコメントはブラウザ版と同じく通常のコメントと区別されません。
  例えば「テスト」スレを新規作成のつもりで投稿しても、既存のスレがネットワークにある場合1番目の投稿にはなりません。

* 通常スレッドキーはそれが作られた時間を表していますが、
  このインターフェイスではそのノードが初めてそのスレッドで手に入れた書き込みを元にしています。
  そのためスレタイが同じでもスレッドキーはノードごとに異なるものになります。
  また>>1以前に書き込みが追加されると新たな>>1の書き込み時間とスレッドキーはずれます。

板
-----------------
2chの板のようにスレを表示できます。

使い方
* まず[こちら](./README.ja.md)の`2ch専用ブラウザから使う場合`を行ってください。
* 通常の新月のインターフェイスで適当なスレにタグを付けます。
  各スレ上部の`タグを編集する`というリンクからできます。
* すると[新月のトップ](http://localhost:8000/gateway.cgi)に次のように表示されます。

  ```
  専ブラカテゴリーはこちら→ 雑談 画像 質問 新月
  ```

  ここにさっき自分でつけたタグが表示されます。
  他のノードで付けられたタグは表示されないので注意してください。
* `雑談`であれば[http://localhost:8001/2ch_E99B91E8AB87/subject.txt](http://localhost:8001/2ch_E99B91E8AB87/subject.txt)にリンクされていますのでそれを専ブラに登録してください。
* ここに自分、あるいは他のノードで`雑談`とタグ付けされたスレが表示されます。

専ブラからスレにタグを付けたい場合
* そのタグの板を開いてください。雑談であれば[ここ](http://localhost:8001/2ch_E99B91E8AB87/subject.txt)。
* スレタイをコピペしてスレ立てしてください。(このスレタイが合っていないと新しくスレが作られてしまいます)。
  このとき本文が通常のレスとして投稿されます。

注意ですが、タグを付けたり、スレを立てたりするのは通常公開ゲートウェイからできません。
sakuをローカルで動かす必要があります。


外部に公開する場合
-------------------

* 公開設定はfile/saku.iniのadmin、friend、visitorを見ています。

* 使うポート(デフォルトで8001)はfile/saku.iniで設定できます。
   doc/sample.iniを参照してください。

* デフォルトだと使っているサーバーが弱いです。
  なので、waitressがある場合そちらを使うようにしています。
  性能が欲しい場合、`pip install waitress`などのコマンドでインストールしてください。
