popup.js
================================================================================

安価先のレスなどに使われるポップアップ UI を提供します。
このプラグイン自体がなにかを行うわけではなく、他のプラグインから参照される
UI ライブラリ的な役割をしています。


機能
--------------------------------------------------------------------------------

- 座標を表すクラスの定義
- 呼び出し元で指定された内容のポップアップを表示
- 現在表示されているポップアップを非表示
- ポップアップの生成や詳細な管理


API
--------------------------------------------------------------------------------

### shingetsu.plugins.Coordinate(DOMEvent event)

`event` が持っているイベントの発生位置を持ったオブジェクトを返します。

##### このコンストラクタを参照するファイル

- 20resanchor.js
- 20imgpopup.js

### shingetsu.plugins.Coordinate(number x, number y, number z)

渡された引数をプロパティとして持ったオブジェクトを返します。

### shingetsu.plugins.hidePopup()

現在表示されている、`shingetsu.plugins.showPopup` によって表示された
ポップアップを非表示にします。

処理の最後で select 要素を表示していますが、
これは何のための処理なのかわからないため残してあります。

##### このメソッドを参照するファイル

- 20response.js
- 20textarea.js
- 20imgpopup.js

### shingetsu.plugins.showPopup(Coordinate coordinate, Elements objects)

`coordinate` が表す位置に `objects` を内容としたポップアップを表示します。
`objects` は jQuery.fn.appendTo() に渡されるので、jQuery オブジェクトや
HTML 文字列なども渡すことができます。

このクラスで表示されるポップアップは排他的です。
例えば、画像のリンクからポップアップを表示した後、そのポップアップが
表示されている状態で Youtube のリンクからポップアップを表示した場合、
先に表示されていた画像のポップアップが非表示にされてから Youtube の
ポップアップが表示されます。

このクラスで表示されるポップアップのコンテナー要素の `id` プロパティには
`popup` が設定されます。また、`className` プロパティにも `popup` が設定されます。

処理の最後で select 要素を非表示にしていますが、
これは何のための処理なのかはわからないため残してあります。

##### このメソッドを参照するファイル

- 20imgpopup.js

### shingetsu.plugins.Popup(Object opt_parameters)

ポップアップを表すオブジェクトを返します。
このクラスで生成されるポップアップは排他的ではないので、複数のポップアップを
表示することができます。
また、それらのポップアップは親子関係を持つことができます。

このクラスで表示されるポップアップのコンテナー要素の `className` プロパティには
`popup` が設定されます。

このクラスは以下の機能を持ちます。

- ポップアップの生成
- 内容の設定
- 子ポップアップの登録
- ポップアップの表示、非表示
- 位置の調整
- 指定されたポップアップが持つ、DOM ノードおよびオブジェクトへの参照の削除
